#include <bits/stdc++.h>

using namespace std;

int a[1000001];

int main() {
	 int n;
	 cin >> n;
	 for(int i = 0; i < n; i++) cin >> a[i];	 		 	
	 
	 if(is_sorted(a, a+n, greater<int>())) {
	 	bool imaIstih = false;
	 	for(int i = 1; i < n; i++) {
	 		if(a[i] == a[i-1]) {
	 			imaIstih = true;
	 			break;
			}
		}
		if(!imaIstih) swap(a[n-1], a[n-2]);		
	 }
	 else {
	 	int l, r, curMax = n-1;
	 	for(int i = n-2; i >= 0; i--) {
	 		if(a[i] > a[curMax]) curMax = i;
	 		if(a[curMax] > a[i]) {
	 			l = i, r = curMax;
			 }
		 }
		 swap(a[l], a[r]);
	 }
	 for(int i = 0; i < n; i++) cout << a[i] << " ";
}